#!/bin/sh
# Скрипт относиться к драйверу модема, запускается после включения питания модема
# Скрипт выполняет:
# Проводит первичную инициализацию модема
# Запускает pre_up_chat_script.sh скрипт для первоначальной настройки модема
# Запускает скрипт соединения ppp_restart.sh
#

workDir="/run/ppp/peers"                # Рабочая директория
preUpScript="/pre_up_chat_script.sh"    # скрипт для запуска chat сценариев отключения автодозвона, включения правильного режима модема и установки IMEI на sim1
pppRestartScript="/ppp_restart.sh"      # Скрипт запускающий pppd
modemDevice="/dev/ttyUSB2"

exitCodeToReset=3
exitCodeToRestart=1
exitCodeOk=0
timeoutFromSimEI=5

echo "++++ Start $0 ++++"

if [ ! -d $workDir ]; then

    echo "Failed to set work dir to $workDir"
    exit $exitCodeToReset

fi

if [ ! -f $workDir$preUpScript ]; then

    echo "Failed to start preUpScript.sh $workDir$preUpScript"
    exit $exitCodeToReset

fi

$workDir$preUpScript

if [ $? -ne 0 ]; then

    echo "Error in $workDir$preUpScript. Reset modem."
    exit $exitCodeToReset

fi

$workDir$pppRestartScript

exit $?
