#!/bin/sh
# Скрипт предназначен для переключения sim-карт и запуска pppd демона
# Скрипт выполняет:
# Управляет переключением на sim0 и sim1
# Запускает pppd с опциями нужного провайдера

workDir="/run/ppp/peers"
optionsProvider1="/etc/ppp/provider1.options"
optionsProvider2="/etc/ppp/provider2.options"
switchToSim0="/switchToSim0"
switchToSim1="/switchToSim1"
modemDevice="/dev/ttyUSB2"
modemDeviceSpeed="115200"
exitCodeToReset=3
exitCodeToRestart=1
exitCodeOk=0

echo "++++ Start $0 ++++"

pppd=$(which pppd)

if [ $? -ne 0 ]; then

    echo "Failed to start pppd"
    exit $exitCodeToReset

fi

# Готовим дескриптор для chat
exec 3<>$modemDevice

# Переключаемся на sim0
chat -v -f $workDir$switchToSim0 >&3 <&3
resultToSwitchSim0=$?

case "$resultToSwitchSim0" in

    0)  # Успешно переключились на sim0

        echo "Successful to switch to sim0 "
        echo "start $pppd file $optionsProvider1 ttyname $modemDevice speed $modemDeviceSpeed"
        $pppd file $optionsProvider1  $modemDevice  $modemDeviceSpeed &

    ;;
    4 | 5)  # Ошибки переключения на sim0
            # 4 - Завершился на первой строчке ABORT - Модем уже переключен на sim0
            # 5 - Завершился на второй строчке ABORT - Произошла ошибка переключения на sim0

        echo "Try to switch to sim1"
        chat -v -f $workDir$switchToSim1 >&3 <&3
        resultToSwitchToSim1=$?

        if [ $resultToSwitchToSim1 -eq 5 ]; then

            # Ошибка переключения на sim1, установлена только sim0
            echo "Only sim0 set to device"
            echo "start $pppd file $optionsProvider1 ttyname $modemDevice speed $modemDeviceSpeed"
            $pppd file $optionsProvider1  $modemDevice  $modemDeviceSpeed  &

        elif [ $resultToSwitchToSim1 -eq 4 ]; then

            # Ошибка переключения на sim1(sim1 уже включена), установлена только sim1
            echo "Only sim1 set to device"
            echo "start $pppd file $optionsProvider2 ttyname $modemDevice speed $modemDeviceSpeed"
            $pppd file $optionsProvider2 $modemDevice $modemDeviceSpeed &


        elif [ $resultToSwitchToSim1 -eq 0 ]; then

            # Успешно переключились на sim1
            echo "Successful to switch to sim1"
            echo "start $pppd file $optionsProvider2 ttyname $modemDevice speed $modemDeviceSpeed"
            $pppd file $optionsProvider2  $modemDevice  $modemDeviceSpeed &

        else

            echo "Chat script ($workDir$switchToSim1) return unknown code($resultToSwitchSim1)!"
            exit $exitCodeToReset

        fi

    ;;
    *)  # Все другие ошибки

        echo "Chat script ($workDir$switchToSim0) return unknown code($resultToSwitchSim0)!"
        exit $exitCodeToReset

    ;;
esac

exit $exitCodeOk
